# ChineseCalendarTools: Documentation


### FUNCTION calendar_dict()

meant to upload the dataset needed for the class (global import)


### CLASS LuniSolarCalendar()


Properties

* 'inputdate': Chinese date as input (string)
* 'normdate': normalised version of inputdate (string), 
* 'period': can either be Qing or Minguo (string)
* 'nianhao': reigning periods from the Qing (string, trad. characters) 
* 'year_ganzhi': one of the ganzhi cycles (string, trad. characters) meant to express year
* 'year_number': number expressed in Chinese characters (string)
* 'intercal': True or False of containing an intercalary month (Binary)
* 'lunar_month': number expressed in Chinese characters (string)
* 'lunar_day': number expressed in Chinese characters (string)
* 'dayganzhi': one of the ganzhi cycles (string, trad. characters) meant to express the day




\_\_init\_\_(self, inputdate)

> Takes in a string containing a Chinese Lunisolar date, normalise the date input, categorize the date according to era (Qing or Republican of China) and set up the following attributes of the object: input date (str), norm date (str), period (str), nianhao (str), year ganzhi or number (str), lunar month (str), intercal (binary), lunar day number/ganzhi (str). It also autocomplete missing information.

normalisation_input()

> Called by the __init__() method; takes __self.inputdate__ as input and returns a normalised version of the Chinese date.


categorise_period()

> Called by the __init__() method; takes __self.normdate__ as input and returns the relevant era (Qing or Republic of China), which is stored in __self.period__


date_parsing()

> Called by the __init()__ method; takes __self.normdate__ as input and uses regular expressions to extract and tag parts of the Chinese date: nianhao, year ganzhi or number, lunar month, intercal, lunar day number/ganzhi. It also autocompletes information of day and year if needed


extract_nianhao(self, chinesedate_string)

> Called by the __date_parsing__() method; relies on regrex to set the nianhao property.

extract_lunar_year(self, chinesedate_string)

> Called by the __date_parsing__() method;  relies on regrex to set the year ganzhi or year number property.

complete_year(self)

> Called by the __date_parsing__() method; autocompletes day ganzhi/year number in case of absence of one of the two.

extract_lunar_month(self, chinesedate_string)

> Called by the __date_parsing__() method; relies on regrex to set the lunar month property.

extract_lunar_day(self, chinesedate_string)

> Called by the __date_parsing__() method; relies on regrex to set the lunar day number property.

complete_lunar_day(self,chinesedate_string)

> Called by the __date_parsing__() method; autocompletes lunar day in case the day is expressed by 望日, 晦, 除夕 or the day ganzhi

within_lsmonth_validation(self)

> Called by the __date_parsing__() method; validates whether the day is within the lunar month

convertDayGangzhi2lunarday(self)

> Called by the __date_parsing__() method; calculates the lunar day via the the extracted day ganzhi property and set up the lunar day number property (string).

chin2arab()

> The function uses regular expressions to divide a Chinese number into usable chunks (in units of "tence" and "once"), converts the chunks to numbers by calling the __converting_number__() and add them up in the end. Only for numbers up to 99.

converting_number()

> Called by the __chin2arab()__ method; The function converts a small Chinese number unit to Arabic.

prepare_index_cards()

> Called by __lunarmonth_status__(), __convertDayGangzhi2lunarday__(), __convert_ls_year__(), __convert_ls_month_start__() and __ganzhi_of_lunar_day__(); provides the relevant indexes that help to retrieve the relevant information from the calendar data dictionary.

lunarmonth_status(self)
> Called by __complete_lunar_day__() and __within_lsmonth_validation__(); verifies whether the lunar month of the input Chinese date is 29 days or 30 days


convert_ls_date(self)

> This function is to convert the Chinese date into Gregorian calendar. The input parameters are the attributes of the LuniSolarCalendar object generated by the init() funtion. The function returns the gregorian date as a string (!).


convert_ls_year()

> This function returns the equivalent in Gregorian calendar for the Chinese year (convert_ls_year!).

convert_ls_month_start(self)

> This function returns the starting gregorian date for the lunar month (string).

convert_ls_month_end(self)
> This function returns the ending gregorian date for the lunar month (string).


Static method: number2ganzhi(number)
> This function converts the ganzhi from integer number to Chinese text (example, 37 becomes 庚子).

Static method: ganzhi2number(gz)
> This function converts the ganzhi from Chinese text to integer number (example, 庚子 becomes 37)


Static method: returnChineseNumber(inputnumber)

> turns integer numbers up to 99 into Chinese numbers

static method: find_ganzhi_in_gregorian_calendar(ganzhi, gregorian_year, time = "after")

> provides the gregorian year of a given ganzhi (input) before/after a certain year.

static method: extract_date_from_text(txt)

> extracts Chinese dates from text with regular expressions.